# transports.h File Reference

`#include <opal/buildopts.h>`
`#include <ptlib/sockets.h>`
`#include <ptclib/psockbun.h>`

Go to the source code of this file.

## Classes

class | OpalTransportAddress
class | OpalListener
class | OpalListenerIP
class | OpalListenerTCP
class | OpalListenerUDP
class | OpalTransport
class | OpalTransportIP
class | OpalTransportTCP
class | OpalTransportUDP
class | OpalInternalTransport
class | OpalInternalIPTransport
class | OpalInternalIPTransportTemplate< ListenerType, TransportType, AltTypeOption, AltTypeClass >

## Typedefs

typedef OpalInternalIPTransportTemplate< OpalListenerTCP, OpalTransportTCP, OpalTransportAddress::Datagram, OpalTransportUDP > | OpalInternalTCPTransport
typedef OpalInternalIPTransportTemplate< OpalListenerUDP, OpalTransportUDP, OpalTransportAddress::Streamed, OpalTransportTCP > | OpalInternalUDPTransport

## Functions

| OpalTransportAddressArray (const OpalTransportAddress &address)
| OpalTransportAddressArray (const PStringArray &array)
| OpalTransportAddressArray (const PStringList &list)
| OpalTransportAddressArray (const PSortedStringList &list)
void | AppendString (const char *address)
void | AppendString (const PString &address)
void | AppendAddress (const OpalTransportAddress &address)
void | AppendStringCollection (const PCollection &coll)
| PLIST (OpalListenerList, OpalListener)
OpalTransportAddressArray | OpalGetInterfaceAddresses (const OpalListenerList &listeners, bool excludeLocalHost, OpalTransport *associatedTransport, PNatMethod *natMethod)
OpalTransportAddressArray | OpalGetInterfaceAddresses (const OpalTransportAddress &addr, bool excludeLocalHost, OpalTransport *associatedTransport, PNatMethod *natMethod)

## Typedef Documentation

typedef OpalInternalIPTransportTemplate<OpalListenerTCP, OpalTransportTCP, OpalTransportAddress::Datagram, OpalTransportUDP> OpalInternalTCPTransport

typedef OpalInternalIPTransportTemplate<OpalListenerUDP, OpalTransportUDP, OpalTransportAddress::Streamed, OpalTransportTCP> OpalInternalUDPTransport

## Function Documentation

void AppendAddress | ( | const OpalTransportAddress & | address | ) |

void AppendString | ( | const PString & | address | ) |

void AppendString | ( | const char * | address | ) |

void AppendStringCollection | ( | const PCollection & | coll | ) | `[protected]`

OpalTransportAddressArray OpalGetInterfaceAddresses | ( | const OpalTransportAddress & | addr,
|  | bool | excludeLocalHost,
|  | OpalTransport * | associatedTransport,
|  | PNatMethod * | natMethod |
| ) |  |  | `[protected]`

Parameters:

  addr | Possible INADDR_ANY address
  excludeLocalHost | Flag to exclude 127.0.0.1
  associatedTransport | Associated transport for precedence and translation
  natMethod | NAT traversal method, e.g. STUN server if used

OpalTransportAddressArray OpalGetInterfaceAddresses | ( | const OpalListenerList & | listeners,
|  | bool | excludeLocalHost,
|  | OpalTransport * | associatedTransport,
|  | PNatMethod * | natMethod |
| ) |  |  | `[protected]`

Return a list of transport addresses corresponding to a listener list

Parameters:

  listeners | List of listeners
  excludeLocalHost | Flag to exclude 127.0.0.1
  associatedTransport | Associated transport for precedence and translation
  natMethod | NAT traversal method, e.g. STUN server if used

OpalTransportAddressArray | ( | const PSortedStringList & | list | ) |

OpalTransportAddressArray | ( | const PStringList & | list | ) |

OpalTransportAddressArray | ( | const PStringArray & | array | ) |

OpalTransportAddressArray | ( | const OpalTransportAddress & | address | ) |

PLIST | ( | OpalListenerList | ,
|  | OpalListener |  |
| ) |  |  | `[protected]`